/// <reference types="node" />
import { Player } from 'lavalink';
import { Redis } from 'ioredis';
import QueueStore from './QueueStore';
import { EventEmitter } from 'events';
export interface NP {
    position?: number;
    track: string;
}
export default class Queue extends EventEmitter {
    readonly store: QueueStore;
    readonly guildID: string;
    readonly keys: {
        list: string;
        np: string;
    };
    constructor(store: QueueStore, guildID: string);
    readonly player: Player;
    start(): Promise<boolean>;
    add(...tracks: string[]): Promise<number>;
    unshift(...tracks: string[]): Promise<number>;
    remove(track: string): PromiseLike<number>;
    next(count?: number): Promise<boolean>;
    trim(start: number, stop: number): PromiseLike<string>;
    stop(): Promise<void>;
    clear(): any;
    current(): Promise<NP | null>;
    tracks(start?: number, end?: number): PromiseLike<string[]>;
    protected readonly _redis: Redis;
}
